package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10081MHQResultBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10081MHQSendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10081MHQCheckPic extends ProtBase {

	private final short iTaskCode10081 = 10081;
	private Gson gson;
	private Prot10081MHQResultBean resMsgBean;
	
	public Prot10081MHQCheckPic() {
		gson = new Gson();

	}
	
	public Prot10081MHQResultBean getResMsgBean() {
		return resMsgBean;
	}

	public void setResMsgBean(Prot10081MHQResultBean resMsgBean) {
		this.resMsgBean = resMsgBean;
	}

	public void dealMHQCheckPic(SocketCreate create,
                                Prot10081MHQSendBean labelBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10081MHQSendBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10081, "开始请求信息");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10081MHQSendBean labelBean)
			throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10081, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10081,"获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10081, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resMsgBean = gson.fromJson(jsonData, Prot10081MHQResultBean.class);
		}
		recCheckCode(dis);
	}




}
